##
## retriver.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 17:52:48 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

from ihooks import *
import dircache

class PluginLister:
    def __init__(self):
        self.list = dircache.opendir("plugins/")
        
        my = list()
        for el in self.list:
            # Consider only ".py"
            if el[-3:] == ".py":
                plug_name = el[:-3]
                plug = PluginLoader(plug_name)
                plug_title = plug.get_name()
                
                my.append((plug_title, plug_name))

        self.list = my
        self.list.sort()
        
    def get_list(self):
        return self.list

class PluginLoader:
    def __init__(self, name):
        bml = BasicModuleLoader()
        stuff = bml.find_module_in_dir(name, "plugins/")
        bml.load_module(name, stuff)

        imp = BasicModuleImporter()
        imp.set_loader(bml)
        
        self.plugin = imp.import_module(name)
        self.plugin = self.plugin.HttpRetriever()

    def query(self, needle):
        return self.plugin.query(needle)

    def get(self, tabinfo):
        return self.plugin.get(tabinfo)

    def get_name(self):
        return self.plugin.get_name()
    
