##
## preferences.py
## Login : <glibersat@localhost.localdomain>
## Started on  Wed Jul 20 20:38:38 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import gtk

import os

class Preferences:
    def __init__(self):
        pref_dir = ".tabgrab" # xx_dir is relative path
        plug_dir = "plugins"  # xx_path is absolute path
        lib_dir = "library"
        
        home = os.environ.get("HOME")

        # Create pref dir if not exists
        self.pref_path = os.path.join(home, pref_dir)
        
        if not os.path.exists(self.pref_path):
            os.mkdir(self.pref_path)

        # Same for plugins dir
        self.plug_path = os.path.join(self.pref_path, plug_dir)

        if not os.path.exists(self.plug_path):
            os.mkdir(self.plug_path)

        # And for library...
        self.lib_path = os.path.join(self.pref_path, lib_dir)

        if not os.path.exists(self.lib_path):
            os.mkdir(self.lib_path)

    def get_library_path(self):
        return self.lib_path

    def get_conf_path(self):
        return self.pref_path

    def get_plugins_path(self):
        return self.plug_path

class MainOptions(gtk.Frame):
    def __init__(self):
        gtk.Frame.__init__(self, "Main options")

        self.table = gtk.Table(1, 2)

        self.add(self.table)

        # Plugin path
        label = gtk.Label("Plugin path : ")
        self.table.attach(label,
                          0, 1,
                          0, 1,
                          gtk.EXPAND,
                          0,
                          0,
                          0
                          )
        
        fc = gtk.Entry()
        self.table.attach(fc,
                          1, 2,
                          0, 1,
                          gtk.EXPAND | gtk.FILL,
                          0,
                          0,
                          0
                          )
        

class PreferencesWindow(gtk.Window):
    def __init__(self):
        gtk.Window.__init__(self)
        self.set_title("User preferences")
        self.set_default_size(400, 400)
        self.set_modal(True)

        vbox = gtk.VBox(2)
        vbox.set_border_width(5)
        
        self.current = MainOptions()
        
        vbox.pack_start(self.current)
        
        self.add(vbox)
