##
## retriver.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 17:52:48 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import urllib, re

class HttpRetriever:
    def __init__(self, source):
        self.source = source

    def query(self, needle):
        # FIXME: Change to right url
        url = urllib.URLopener()
        fd = url.open_file("/home/glibersat/tabs/search2.php3.html")

        tab = ""
        for line in fd.readlines():
            tab += line.decode("utf8", 'replace')

        # Extract result list
        start = tab.find("<!-- Search Field -->")
        end = tab.find("<!-- / Search Field -->")
        tab = tab[start:end]


        data = list()

        # Remove useless lines
        rgx = re.compile("<td>.*</td>")
        res = rgx.findall(tab)

        # Prepare regex
        rg_artist = re.compile("<td>. <a href.+<b>.+</b>")
        rg_title = re.compile("<td><a.+<b>.+.+</b>")
        rg_rate = re.compile("<td><img.+></td>")
        rg_type = re.compile("<td><b>.+</b></td>")

        # Extract data
        for el in res:
            # Artist
            if rg_artist.search(el):
                start = el.find("<b>") + 3
                end = el.find("</b>")
                artist = el[start:end]
                #print artist

            # Title
            elif rg_title.search(el):
                start = el.find("<b>") + 3
                end = el.find("</b>")
                title = el[start:end]

                # On this site, version is contained in title
                if title[-1:] == ")":
                    title, version = title.rsplit("(", 1)
                    version = version[:-1]
                    title = title.rstrip(" ")
                else:
                    version = "ver 1"
                # print title, version

            # Rating
            elif rg_rate.search(el):
                start = el.find("/") + 1
                end = el.find(".gif")
                rate = el[start:end]
                #print rate

            # Type
            elif rg_type.search(el):
                start = el.find("<b>") + 3
                end = el.find("</b>")
                type = el[start:end]
                if type == "Bass Tabs":
                    type = "Bass Tab"
                elif type == "Tabs":
                    type = "Guitar Tab"
                elif type == "Chords":
                    type = "Guitar Chords"

                # Add data !
                data.append((artist, title, version, type, rate, self.source))

        fd.close()

        return data

    def get(self, tabinfo):
        ''' When we ask retriever to grab tab on the net '''

        # FIXME : right url
        url = urllib.URLopener()
        fd = url.open_file("/home/glibersat/tabs/a_quick_peep_ver2_tab.htm")
        
        tab = ""
        for line in fd.readlines():
            tab += line.decode("utf8", 'replace')

        # Try to get only tab
        off = tab.find("<xmp")
        tab = tab[off:]

        off = tab.find(">")
        tab = tab[off+1:]
        
        off = tab.find("</xmp>")
        tab = tab[:off]
        
        fd.close()

        return tab


