#!/usr/bin/python

##
## tabgrab.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 14:03:30 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

from search import *
from result import *
from tabview import *
from source import *
from menu import *
from preferences import *
from library import *

import gtk, gobject

version="0.3"

def main():
    prefs = Preferences()
    MainWindow()
    gtk.main()


class MainWindow(gtk.Window):
    def __init__(self, parent=None):
        gtk.Window.__init__(self)

        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect("destroy", gtk.main_quit)

        self.set_title("TabGrab")
        self.set_default_size(800, 400)
        self.set_position(gtk.WIN_POS_CENTER)
        logo = gtk.gdk.pixbuf_new_from_file("logo.png")
        gtk.window_set_default_icon_list(logo)

        # Main table
        vbox = gtk.VBox(2)
        vbox.set_homogeneous(False)

        # Create menu
        self.menu = MainMenu()
        self.add_accel_group(self.menu.ui.get_accel_group())
        vbox.pack_start(self.menu, False, False, 0)
        
        # Create bottom part
        self.main_table = MainTable()
        vbox.pack_start(self.main_table, True, True, 0)
        
        self.add(vbox)

        self.show_all()

        self.statusbar_push("TabGrab ready")

    def statusbar_push(self, msg):
        self.main_table.statusbar.push(0, msg)

        
class MainTable(gtk.VBox):
    def __init__(self):
        gtk.VBox.__init__(self, 2)
        self.set_homogeneous(False)
        
        paned = gtk.HPaned()
        paned_right = gtk.VBox(2)
        paned_right.set_homogeneous(False)

        # Create tabs
        nbk = gtk.Notebook()
        
        
        # Create Library selector
        self.librarysel = LibrarySelector()
        nbk.append_page(self.librarysel, gtk.Label("Library"))


        # Create Network Source selector
        self.sourcesel = SourceSelector()
        nbk.append_page(self.sourcesel, gtk.Label("Network"))
        
        # Create result view
        self.resultview = ResultView()
        paned_right.pack_end(self.resultview, True, True, 0)
        
        # Create the search box
        self.searchbox = SearchBox(self.resultview.update)
        paned_right.pack_start(self.searchbox, False, False, 0)

        # Create statusbar
        self.statusbar = gtk.Statusbar()

        nbk.connect("switch-page", self.switch_mode)
        paned.add1(nbk)
        paned.add2(paned_right)
        self.pack_start(paned, True, True, 0)
        self.pack_start(self.statusbar, False, False, 0)


    # Those functions switch tabgrab to local or network mode
    def set_local_mode(self):
        self.searchbox.set_local_mode()
    def set_network_mode(self):
        self.searchbox.set_network_mode()
        
    def switch_mode(self, notebook, page, page_num):
        if page_num == 0:
            self.set_local_mode()
        elif page_num == 1:
            self.set_network_mode()


if __name__ == "__main__":
    main()
