##
## viewwindow.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 18:03:59 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import gtk

from tabview import *
from plugins import *
from menu import *

from library import LibraryManager

class ViewWindow(gtk.Window):
    def __init__(self, tabinfo):
        gtk.Window.__init__(self)
        self.set_title("View tab")
        self.set_default_size(800, 600)

        # Unpack data
        artist, title, version, type, note, source, recordt, userstr = tabinfo

        # Main vbox
        self.vbox = gtk.VBox(2, False)
        self.vbox.set_border_width(3)
        self.vbox.set_homogeneous(False)
        self.add(self.vbox)


        # Do we need to show Add or Remove button (library)
        if recordt == "library":
            mode = 1
        elif recordt == "net":
            mode = 0

        self.menu = ViewWindowMenu(mode)
        self.add_accel_group(self.menu.ui.get_accel_group())
        self.vbox.pack_start(self.menu, False, True, 0)

        # Tab view and frame
        self.tabview = TabView()
        self.tabview.set_border_width(8)
        
        tabframe = gtk.Frame("Tab")
        tabframe.add(self.tabview)
        self.vbox.pack_start(tabframe, True, True, 0)

        # Save and extracts info
        self.tabinfo = tabinfo

        self.tab = None

        # Do we load from library ?
        if recordt == "library":
            ll = LibraryManager()
            self.tab = ll.load(userstr)

        # Or from net ?
        elif recordt == "net":
            # Guess which source it is from, and load tab
            plugins = PluginLister()
            plugins = plugins.get_list()
            
            for plug in plugins:
                if plug[0] == source:
                    retr = PluginLoader(plug[1])
                    self.tab = retr.get(tabinfo)

                
        if self.tab != None:
            self.set_title("View tab : %s [%s] by %s" % (title, version, artist))
            lbl = gtk.Label(" <b>%s [%s]</b> by <b>%s</b> - <i>%s</i> " % (title, version, artist, type))
            lbl.set_use_markup(True)
            tabframe.set_label_widget(lbl)
            self.tabview.load(self.tab)
        else:
            self.tabview.load("Error!")


        # If our parent needs to reload library
        self.library_needs_update = 0
